#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/soundcard.h>
#include "fmplib.h"

#define CHANNEL 1
#define PROGRAM 0
#define REVERB 16
unsigned long MSECSPEREIGHTH=175000;

/* PITCH stuff */
#define TON(i) (48+i)
#define VEL(i) 100
#define PITCH_TYPE char
#include "mypitch.h"

void init()
{
  const unsigned char program=PROGRAM;
  fm_init();
  fm_program(CHANNEL,program);
  PITCH_INIT;
}

void tini()
{
  usleep(MSECSPEREIGHTH*REVERB);
  fm_tini();
}

FILE *infile;
void writetrack()
{
  long i,l;

#define NOTEOFF(i) fm_noteoff(CHANNEL,pitch[2*(i)],pitch[2*(i)+1])
#define NOTEON(i)  fm_noteon(CHANNEL,pitch[2*(i)],pitch[2*(i)+1])
#define WAIT       usleep(MSECSPEREIGHTH/2)
    init();
#include "my.h"

    tini();
}

int main(int argc,char **argv)
{
  unsigned char buf1[5],buf2[5];
  if((argc>1)&&strcmp(argv[1],"-"))
    infile=fopen(argv[1],"r"); else infile=stdin;
  setbuf(infile,NULL); setbuf(stdout,NULL);

  if(argc>2) MSECSPEREIGHTH=atoi(argv[2]);

  if(infile!=NULL)
    writetrack();
}

